<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Document</title>
    <style>
      .btn {
        display: inline-block;
        text-decoration: none;
        color: red;
        padding: 10px 15px;
        border: 1px solid red;
        border-radius: 5px;
        background-color: #fff;
      }
      .btn1 {
        display: inline-block;
        text-decoration: none;
        color: red;
        padding: 10px 15px;
        border: 1px solid blue;
        border-radius: 5px;
        background-color: #fff;
      }
    </style>
  </head>

  <body>
    <a href="#" id="btn-test" class="btn">Click me!</a>
    <a href="#" id="btn-test1" class="btn1">Click me again!</a>
    <script>
      // this - внутренняя переменная функци, которая при вызове
      // функции всегда ссылается на объект,
      // КОТОРОМУ принаджелит функция В МОМЕНТ ВЫЗОВА.

      // isAdult(); // this === Window

      // console.log1 = function () {
      //   console.log(this);
      // };

      // console.log1(); // context ---> console

      // function isAdult(age) {
      //   console.log(this);
      //   return age > 18;
      // }

      // // // при объявлении в глобальной области видимости функция принадлежит глобальному объекту Window
      // console.log(window.isAdult);

      // // в момент клика функция reverseBtn будет принадлежать кнопке, а значит и this будет ссылаться на нее
      // const button = document.getElementById("btn-test");
      // button.addEventListener("click", reverseBtn);

      function reverseBtn(fontSize) {
        // console.log(this);
        const { color, backgroundColor } = window.getComputedStyle(this);
        this.style.color = backgroundColor;
        this.style.backgroundColor = color;
        this.style.fontSize = fontSize;
      }

      const bodyEl = document.body;
      const btn2 = document.getElementById("btn-test1");

      // reverseBtn();

      // reverseBtn.apply(bodyEl, ["56px"]);
      // reverseBtn.call(btn2, "56px");
      const bindedFunc = reverseBtn.bind(btn2, ["56px"]);
      // bindedFunc();
      // reverseBtn(); // в момент вызову функции она будет принадлежать глобальному объекту Window, а значит и this будет ссылать ся на него
    </script>
  </body>
</html>
